Subject: Re: bash won't hand off to perl (reprise)
From: [email-masked] (Stephen Williams)

28 Mar 1997 15:16:44 -0800
Approved: [email-masked]
Distribution: cygnus
Message-ID: <[email-masked]>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Mailer: exmh version 1.6.7 05/05/96
Original-To: JP Shipherd <[email-masked]>, [email-masked]
In-reply-to: Your message of "Thu, 20 Mar 1997 12:12:37 PST."
             <[email-masked]> 
Original-Sender: [email-masked]

[email-masked] said:
> I posted a while back complaining that bash.exe wouldn't hand off to 
> the right command interpreter even if the shell script started with 
> something like:

#!/usr/local/bin/perl

[email-masked] said:
> However, the following still does not work: 

%> /bin/sh perl-script.pl

[email-masked] said:
> In this case bash still tries to process the file as if it is a 
> bourne shell script.

As it should. The '#' character marks a comment for bourne shell, so is
ignored. And anyhow, /bin/sh does not and should not check the magic number
of a file to see if it an a.out or coff or whatever, it accepts a text file.
However, it you try:

	/bin/sh -c ./perl-script.pl

Then you will get what I think you are trying to achieve. Notice the -c switch,
which tells sh to interpret this as a command, and so pass the perl-script.pl
file to exec(2), which is where the magick numbers are examined and the
correct interpreter selected.

'k?

-- 
Steve Williams
[email-masked]
[email-masked]

"The woods are lovely, dark and deep.  But I have promises to keep,
And lines to code before I sleep, And lines to code before I sleep."

-
For help on using this list, send a message to
"[email-masked]" with one line of text: "help".